class Edge {
  Ball ball1;
  Ball ball2;
  float x1;
  float y1;      
  float x2;
  float y2;
    
  Edge( Ball _ball1, Ball _ball2 ) {   
    ball1 = _ball1;
    ball2 = _ball2;     
  }
  
  void update() {    
    getNodes();    
    displayTriangle();       
  }
  
  void getNodes(){
    x1 = ball1.position.x;
    y1 = ball1.position.y;      
    x2 = ball2.position.x;
    y2 = ball2.position.y;
  }
  
  void displayOverlayLine() {
    float x2Steps; 
    float y2Steps;
    float strokeWidth = 1.5*ball1.r;            
    
    stroke(204, 7);
    
    for (float i=0; i<=3; i++){        
        strokeWeight(strokeWidth * (1-i/4)) ;
        x2Steps = x1 + (x2-x1) * i/3;
        y2Steps = y1 + (y2-y1) * i/3;
        line(x1, y1, x2Steps , y2Steps);
      }  
    }
  
  void displayMultiLine(){    
      stroke(204, 30);
      fill(204, 0);
      float stretch = 0.5;
      float theta = -PI/2 + atan2( y2 - y1, x2 - x1 );
      float sin = sin(theta);
      float cosin = cos(theta);
    
    for (int i=0; i<3; i++){
  
        triangle(x1, y1, x2-i*ball2.r*stretch*cosin,  y2-ball2.r * i * stretch*sin, x2+i*ball2.r*stretch*cosin, y2+ball2.r* i * stretch*sin);
    }
  }

    void displayTriangle() {
      stroke(204, 80);
      fill(204, 10);
      float stretch = 0.6;
      float theta = -PI/2 + atan2( y2 - y1, x2 - x1 );
      float sin = sin(theta);
      float cosin = cos(theta);      
      triangle(x1, y1, x2-ball2.r*stretch*cosin,  y2-ball2.r*stretch*sin, x2+ball2.r*stretch*cosin, y2+ball2.r*stretch*sin);  
    }
    
      
   
}