import java.util.List;

final int MAX_BALLS = 20; 
ArrayList<Ball> balls;
ArrayList<Edge> edges;
Table wordTable;

void initialize(){
  int i;
  int ballId = 0;
  int checkouts;  
  int wordNum;  
  String word;
  balls = new ArrayList<Ball>();
  edges = new ArrayList<Edge>();
  
    
  for (i = 0; i < wordTable.getRowCount(); i++){
    checkouts = wordTable.getInt(i, 0);    
    wordNum =  wordTable.getInt(i, 2);
    word =  wordTable.getString(i, 3);
    
    boolean ballAllreadyExists = false;
    for (Ball ball :  balls){      
      if ( ball.label.equals(word) ) {        
        ballAllreadyExists = true;
        ball.addWordNum(wordNum);  
      } 
    }
    
    if (ballAllreadyExists == false){
      int radius = calcRadius(checkouts);
      Ball ball =new Ball(ballId, word, radius);
      balls.add( ball);
      ball.addWordNum(wordNum);
      ballId++;      
    }
  }
  
  for (Ball ball1 :  balls){
    for (Ball ball2 :  balls){
      for (int wordNum1 : ball1.wordNums) {
        for (int wordNum2 : ball2.wordNums) {
          if (wordNum2 == wordNum1 +1) {
            edges.add( new Edge(ball2, ball1));
          }     
        }
      }
    }
  }
}
  
  
int calcRadius(int checkouts){
  int maxCheckouts = wordTable.getInt(0,0);
  int radius = checkouts/maxCheckouts * 30 + 27;
  return radius;  
}

void setup() {  
  //frameRate(30);
  size(1400, 900);  
  smooth();
    
  wordTable = loadTable("v1.csv");
  wordTable.sort(0);
  
  PFont mono;
  mono = createFont("Helvetica.ttf", 32);   
  textFont(mono);     
  textSize(12); 
  
  initialize();
}

void drawTitle(){
    fill(204, 80);    
    rect(0.8 *width -20 , 20, width*0.2, height*0.1);    
    stroke(50, 200);
    textAlign(LEFT);
    textSize(24);
    text("This is the shit", 0.8*width , 50);    
}


void draw() {
  background(50);    
  for ( Edge e : edges ) e.update();
  for ( Ball p : balls ) p.update();
  
  //drawTitle();  
  
  
}